#include "delay.h"
#include <math.h>

void varesky_del_setup(varesky_delay *s, float *buf, int size, float delay)
{
    s->size = size;
    s->buffer = buf; //(float*)malloc(sizeof(float)*s->size);
    s->delay = delay;
    s->wr = 0;
    varesky_del_set(s, 0, 0.5, 0.5);
}
void varesky_del_free(varesky_delay *s)
{
    // free(s->buffer);
}


void varesky_del_write(varesky_delay *s, float sample)
{
    s->buffer[s->wr] = sample;
    s->wr = (s->wr + 1) & (s->size - 1);
}
float varesky_del_read(varesky_delay *s, float delay)
{
    return s->buffer[(s->wr - (int)delay) & (s->size - 1 )];
}

float varesky_del_process(varesky_delay *s, float in)
{
    static float tmp;
    static int i,pos;
    static float frac;
    static float s1,s2;

    // allpass interp
    i = floor(s->delay);
    frac = s->delay - i;
    pos = (s->wr - i) & (s->size - 1);
    s1 = s->buffer[pos];
    s2 = s->buffer[(pos + 1) & (s->size - 1)];
    frac = (1 - frac) / (1 + frac);
    s->tmp = frac * s2 + s1 - frac * s->tmp;
    tmp = s->tmp;

    //linear interp
    // i = floor(s->delay);
    // frac = s->delay - (float)i;
    // pos = (s->wr - i) & (s->size - 1);
    // s1 = s->buffer[pos];
    // s2 = s->buffer[(pos + 1) & (s->size - 1)];
    // tmp = s1 + frac * (s2 - s1);

    s->buffer[s->wr] = in + s->fdb * tmp;
    tmp = s->wet * tmp + s->dry * in;

    s->wr = (s->wr + 1) & (s->size - 1);

    return tmp;
}
void varesky_del_set_delay(varesky_delay *s, float delay)
{
    s->delay = delay;
}
void varesky_del_set(varesky_delay *s, float fdb, float dry, float wet)
{
    s->fdb = fdb;
    s->dry = dry;
    s->wet = wet;
}

float varesky_del_get(varesky_delay *s, int delay)
{
    return s->buffer[(s->wr - delay) & (s->size-1)];
}

float varesky_ap_process(varesky_delay *ap, float in, float g, float delay)
{
    static float read;
    static float tmp;

    read = ap->buffer[ (ap->wr - (int)delay) & (ap->size - 1)];

    tmp = in - g * read;

    ap->buffer[ap->wr] = tmp;
    ap->wr = (ap->wr + 1) & (ap->size - 1);

    //return g * ap->tmp + read;
    return g * tmp + read;
}

float varesky_ap_process2(varesky_delay *ap, float in, float g, float delay)
{
    static float read;
    static float tmp;
    static int i, pos;
    static float frac;
    static float s1, s2;

    // allpass interp
    i = floor(delay);
    frac = delay - i;
    pos = (ap->wr - i) & (ap->size - 1);
    s1 = ap->buffer[pos];
    s2 = ap->buffer[(pos + 1) & (ap->size - 1)];
    frac = (1 - frac) / (1 + frac);
    ap->tmp = frac * s2 + s1 - frac * ap->tmp;
    read = ap->tmp;

    // read = ap->buf[(ap->wr - ap->delay) & (ap->size - 1)];

    tmp = in + g * read;

    ap->buffer[ap->wr] = tmp;
    ap->wr = (ap->wr + 1) & (ap->size - 1);

    return -g * tmp + read;
}