#ifndef REVERB_VARESKY
#define REVERB_VARESKY

typedef struct varesky_plate
{

} varesky_plate;

typedef struct varesky_lfo
{
    float state;
    float rate;
    float inc;
    float samplerate;
} varesky_lfo;

typedef struct varesky_allpass
{

    float *buf;
    float g, tmp1, tmp2;
    int wr, delay, size;
} varesky_allpass;

float ms2samps(float ms);

void varesky_plate_set_bandwidth(float val);
void varesky_plate_set_damping(float val);
void varesky_plate_set_decay(float val);
void varesky_plate_set_mix(float val);

void varesky_plate_init(float samplerate);
float varesky_plate_process(float in);
void varesky_plate_process_block(const float *in,float *out, int framesPerBuffer);

void v_init_allpass(varesky_allpass *ap, float *buf, int size, float g, int delay);
float v_allpass_get(varesky_allpass *ap, int delay);
float v_allpass_process(varesky_allpass *ap, float in);
float v_allpass_process2(varesky_allpass *ap, float in, float delay);

float v_read(float *arr, int pos, int size);

void v_lfo_init(varesky_lfo *lfo, float samplerate, float rate, float startPhase);
void v_lfo_set_rate(varesky_lfo *lfo, float rate);
float v_lfo_process(varesky_lfo *lfo);

#endif