#ifndef ARM_AUDIO_H
#define ARM_AUDIO_H

#include "portaudio.h"
#include "pa_linux_alsa.h"

// turn on/off audio system
#define AudioON 1
#define SAMPLE_RATE (48000)
#define PA_SAMPLE_TYPE paFloat32
#define FRAMES_PER_BUFFER (512)
#define N_CHANNELS (2)

PaStreamParameters inputParameters, outputParameters;
PaStream *stream;
PaError err;

int startAudio(void);
int stopAudio(void);

extern int audioCallback(const void *inputBuffer, void *outputBuffer,
                         unsigned long framesPerBuffer,
                         const PaStreamCallbackTimeInfo *timeInfo,
                         PaStreamCallbackFlags statusFlags,
                         void *userData);

#endif
